package com.ibm.jikes.skij; 

/* This file is part of Skij.
 * Author: Michael Travers (mt@watson.ibm.com)
 * 
 * Licensed Materials - See the file license.txt.
 * (c) Copyright IBM Corp. 1997, 1998. All rights reserved.
 */

public abstract class Procedure {

  public Symbol name;

  abstract String shortClassName();

  public abstract Object apply(Environment within, Cons args) throws SchemeException;

  public Object safeTopApply(Cons args) {
    try {
      return apply(Environment.top, args);
    }
    catch (SchemeException e) {
      System.out.println("error within " + this + ".safeApply: " + e.toString());      
      return null;
    }
  }

  public String toString() {
    if (name == null)
      return "[" + shortClassName() + " <anon> @" + Integer.toHexString(hashCode()) + "]";
    else
      if (this == Environment.top.getBindingSafe(name)) {
	return "[" + shortClassName() + " " + name + "]"; } // top-level procs don't get hash id
      else
	return "[" + shortClassName() + " " + name + " @" + Integer.toHexString(hashCode()) + "]";
  }

  public void define(Environment env) {
    env.addBinding(name, this);
  }

}

  
