package com.ibm.jikes.skij;  
import java.io.*;

/* This file is part of Skij.
 * Author: Michael Travers (mt@watson.ibm.com)
 * 
 * Licensed Materials - See the file license.txt.
 * (c) Copyright IBM Corp. 1997, 1998. All rights reserved.
 */

public class SchemeReader extends Reader {
  
  // provides hooks so you can define Readers in Skij.

  Procedure read;
  Procedure close;

  public SchemeReader(Procedure r, Procedure c) {
    read = r; close = c;
  }

  public int read(char[] chars, int start, int size) throws IOException {
    try {
      return ((Integer)read.apply(Environment.top, Cons.list(chars, new Integer(start), new Integer(size)))).intValue(); }
    catch (SchemeException e) {
      throw new java.io.IOException(e.toString());
    }
  }

  public void close() throws java.io.IOException {
    try {
      close.apply(Environment.top, Nil.nil); }
    catch (SchemeException e) {
      throw new java.io.IOException(e.toString());
    }
  }
}
