package com.ibm.jikes.skij;
import java.io.*;


/* This file is part of Skij.
 * Author: Michael Travers (mt@watson.ibm.com)
 * 
 * Licensed Materials - See the file license.txt.
 * (c) Copyright IBM Corp. 1997, 1998. All rights reserved.
 */

public class SchemeWriter extends Writer {
  
  Procedure write;
  Procedure close;
  Procedure flush;

  public SchemeWriter(Procedure w, Procedure c, Procedure f) {
    write = w; close = c; flush = f;
  }

  public void write(char[] chars, int start, int size) throws IOException {
    try {
      write.apply(Environment.top, Cons.list(chars, new Integer(start), new Integer(size))); }
    catch (SchemeException e) {
      throw new java.io.IOException(e.toString());
    }
  }

  public void close() throws java.io.IOException {
    try {
      close.apply(Environment.top, Nil.nil); }
    catch (SchemeException e) {
      throw new java.io.IOException(e.toString());
    }
  }

  public void flush() throws java.io.IOException {
    try {
      flush.apply(Environment.top, Nil.nil); }
    catch (SchemeException e) {
      throw new java.io.IOException(e.toString());
    }
  }
}

