;;; This file is part of Skij.
;;; Author: Michael Travers (mt@watson.ibm.com)

;;; Licensed Materials - See the file license.txt.
;;; (c) Copyright IBM Corp. 1997, 1998. All rights reserved.

;;; Common-Lispy extensions

; local extension (from CL)
(defmacro (push thing place)
  `(set! ,place (cons ,thing ,place)))

(defmacro (pushnew thing place)
  `(if (memq ,thing ,place) #f
       (set! ,place (cons ,thing ,place))))

; local extension (from CL)
(defmacro (pop place)
  `(let ((result (car ,place)))
     (set! ,place (cdr ,place))
     result))

; local extension: returns #t or #f
(define (bound? symbol)
  (not (%%null? (invoke (current-environment) 'getBindingSafe symbol))))

  