;;; This file is part of Skij.
;;; Author: Michael Travers (mt@watson.ibm.com)

;;; Licensed Materials - See the file license.txt.
;;; (c) Copyright IBM Corp. 1997, 1998. All rights reserved.

(define (directory dir)
  (define fileobj (new 'java.io.File dir))
  (define filarray (invoke fileobj 'list))
  (vector->list filarray))

; +++ these should use dynamic-wind to close stream?
(define (with-input-file file func)
  (define ins (new 'java.io.FileInputStream file))
  (func (new 'com.ibm.jikes.skij.InputPort ins)))

(define (with-output-file file func)
  (define outss (new 'java.io.FileOutputStream file))
  (func (new 'com.ibm.jikes.skij.InputPort outs)))
  
(define (with-open-for-append file proc)
  (let ((stream #f)
	(port #f))
    (dynamic-wind
     (lambda ()
       (set! stream
	     (new 'java.io.FileOutputStream (invoke file 'getPath) #t)) ;open for append
       (set! port (new 'com.ibm.jikes.skij.OutputPort stream)))
     (lambda () (proc port))
     (lambda ()
       (invoke stream 'close)))))

;;; apply procedure w recursive descent
(define (for-all-files proc dir)
  (define (process fileobj)
    (if (invoke fileobj 'isDirectory)
	(for-vector (lambda (name)
		      (process
		       (new 'java.io.File fileobj name)))
		    (invoke fileobj 'list))
	(proc fileobj)))
  (process (new 'java.io.File dir)))
  
  