package com.ibm.jikes.skij.util;

/* This file is part of Skij.
 * Author: Michael Travers (mt@watson.ibm.com)
 * 
 * Licensed Materials - See the file license.txt.
 * (c) Copyright IBM Corp. 1997, 1998. All rights reserved.
 */

public class Tracer {

  /* hierarchical debugging output

     note: we have a global debugging flag, but it is bad to leave in trace code turned
     off with the flag, since the trace args will still get evaluated. (hint: if this 
     was Lisp, we could use macros and this wouldn't be a problem).

     */
  
  public static boolean on = false;
  public static int level = 0;

  public static void setOn(boolean newOn) {
    on = newOn; }

  // print a string at the appropriate level
  public static void tracePrint(String msg) {
    if (on) {
      System.out.println();
      for (int i = 0; i != level; i = i+1) 
	System.out.print("  "); 
      System.out.print(msg);
    }
  }

  public static int traceIn(String msg) {
    tracePrint(msg);
    return level = level + 1;
  }
  
  public static void traceOut() {
    level = level - 1; }

  public static void traceOut(String msg) {
    level = level - 1; 
    tracePrint(msg);
  }

  public static void traceOut(int lev) {
    level = lev - 1; }

  public static void traceOut(int lev, String msg) {
    level = lev - 1; 
    tracePrint(msg);
  }


  public static void main(String argv[]) {
    System.out.println("fact(10)=" + fact(10));
  }

  static int fact(int n) {
    traceIn("enter fact " + n);
    if (n == 0)
      {traceOut("return 1"); return 1;}
    else {
      int result = n * fact(n - 1);
      traceOut("return " + result); return result; }
  }
}
